# Msequence Encoder and Decoder

M系列符号を使って、拡散信号を生成し、それを逆拡散して自己相関を算出するサンプルプログラムです。

# Installation

 C言語がコンパイルできる環境で makeコマンドを実行するだけです。
 encodeとdecodeの2つのプログラムが生成されます。

# Usage

encode -a (signal_volume) -o (output_wavefile)  
decode -s (start_time) (decoding_wavefile)

# Sample

./encode -o sample.wav

(sample.wavを生成します)

./decode -s 2 sample.wav

(sample.wavの2秒目から逆拡散して自己相関値を計算します。そこから1サンプルごとにずらして算出した自己相関値を
出力します。）

./decode -s 2 sample.wav -o result.csv

-oオプションをつけて出力ファイルを指定すれば、自己相関値の結果をファイルにCSV形式で出力します。


# Note

encodeプログラムは、M系列符号を位相変調した信号を生成して、waveファイルに書き込みます。
このwaveファイルをそのまま使ってもよいのですが、スピーカから再生しマイクで録音して
waveファイルを生成すると、音響経路のインパルス応答に近いものが求められます。
録音waveファイルをdecodeプログラムで処理すると、上記のM系列符号の信号と、１サンプルずつ
シフトしながら自己相関値を算出します。最も高いサンプル点が同期点でもあり、
この系列がインパルス応答に近いものにもなります。

# Msequence Code

M系列符号は、生成多項式から生成します。生成多項式は各次元ごとに複数ありますが、
下記に1つの例を示します。ここにある SpreadingRate, Generator, MaxBit, XorBitを
msequence.hの値に書き換えると拡散率を変更したプログラムをコンパイルできます。
デフォルトでは、拡散率255にセットされています。

 [Spreading Rate, Polynomials, Generator, MaxBit, XorBit]
 15,  x^4 + x + 1,  11,  0x0010,  0x0013
 31,  x^5 + x^2 + 1, 101, 0x0020, 0x0025
 63,  x^6 + x + 1,  11, 0x0040, 0x0043
 127, x^7 + x + 1,  11, 0x0080, 0x0083
 255, x^8 + x^4 + x^3 + x^2 + 1, 11101,  0x0100, 0x011d
 511, x^9 + x^4 + 1, 10001, 0x0200, 0x0211






