/*
 *  Msequence Encoder and Decoder
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <fcntl.h>
#include <math.h>
#include "msequence.h"

int main(argc, argv)
     int argc;
     char **argv;
{
  int i, j, n, in, op;
  char *input, *buf;
  unsigned char *code;

  int length = (ChipWidth * SpreadingRate);
  int readsize = length * (AnalyzeFrame + 1) * sizeof(short);
  short *x, *p;
  double *c, *self, val;
  
  /* option */
  int offset = 0;
  char *output = "result.csv";
  FILE *fp;
  int flag = 0;
    

  

  while((op = getopt(argc, argv, "s:f:o:")) != EOF){
    switch(op){
    case 's':
      offset = atoi(optarg) * SF * sizeof(short);
      break;
    case 'o':
      output = optarg;
      flag = 1;
      break;
    default:
      perror("invalid option");
      exit(1);
    }
  }

  argc -= optind;
  argv += optind;

  if(argc == 1){
    input = argv[0];
  }else{
    printf("Usage: decode <decoding_wavefile>\n");
    exit(1);
  }

  buf = (char *)malloc(readsize);
  x = (short *)malloc(length * (AnalyzeFrame + 1) * sizeof(short));



  code = (unsigned char *)code_generator();
  printf("[Msequence Bits]\n");
  for(i = 0; i < SpreadingRate; i++){
    printf("%d", code[i]);
  }
  printf("\n");
  
  self = modulation(code, ChipWidth);
  

  /* File Open */
  in = open(input, O_RDONLY);
  if(in < 0){
    perror("input wave file open.");
  }
  lseek(in, offset+44, SEEK_SET);

  /* Read Decoding Data */
  n = read(in, (char *)buf, readsize);
  if(n < readsize){
    exit(1);
  }

  /* Decoding Data */
  p = (short *)buf;
  for(i = 0; i < (length * (AnalyzeFrame + 1)); i++){
    x[i] = *p;
    p++;
  }
  c = self_correlation(self, x, length, AnalyzeFrame);

  if(flag){
    fp = fopen(output, "w");
    for(i = 0; i < (length * AnalyzeFrame); i++){
      fprintf(fp, "%d, %lf\n", i, c[i]);
    }
    fclose(fp);
  }else{
    for(i = 0; i < (length * AnalyzeFrame); i++){
      printf("[%d] %lf\n", i, c[i]);
    }
  }

}    



