/*
 *  Msequence Encoder and Decoder
 */

#include<stdio.h>
#include<stdlib.h>
#include<unistd.h>
#include<math.h>
#include "msequence.h"


char * code_generator()
{

  int i;
  char *code;
  unsigned int shift = Generator;

  code = (char *)calloc(SpreadingRate, sizeof(char));

  for(i = 0; i < SpreadingRate; i++){
    if(shift & 0x01){
      code[i] = 1;
    }else{
      code[i] = 0;
    }
    shift = shift << 1;
    if(shift & MaxBit){
      shift = shift ^ XorBit;
    }
  }

  return(code);

}

double * modulation(unsigned char *code, int chipwidth){

  int i, j;
  double *data;
  double rad, drad;
  int length = SpreadingRate * chipwidth;
  
  drad = (2 * M_PI) / chipwidth;
  rad = 0.0;
  data = (double *)malloc(length * sizeof(double));
  
  for(i = 0; i < SpreadingRate; i++){
    for(j = 0; j < chipwidth; j++){
      data[(i*chipwidth)+j] = sin(rad);
      if(code[i]){
	rad += drad;
      }else{
	rad -= drad;
      }
    }
    rad = 0.0;	
  }

  return data;

}


double *self_correlation(double *self, short *data, int length, int nframes){

  int i, j;
  double *sc, val;
  
  sc = (double *)malloc(length * nframes * sizeof(double));

  for(i = 0; i < (length * AnalyzeFrame); i++){
    val = 0.0;
    for(j = 0; j < length; j++){
      val += (self[j] * data[i+j]);
    }
    sc[i] = fabs(val);
  }

  return sc;

}
